#copyright 2009 Chris Fullmer.  No permission given to tweak, repost, alter, sell, distribute, publish this code.

require 'sketchup.rb'

class Clf_password_protector

def activate
	if Sketchup.active_model.attribute_dictionary "clf_pw"
		attrdict = Sketchup.active_model.attribute_dictionary "clf_pw"
		$clf_pw_set = attrdict['pw_set']
	end
	main
end

def main
	model = Sketchup.active_model
	ents = model.entities
	set_pw
end

def set_pw
	if $clf_pw_set
		prompts = ["Enter the existing Password ", "Enter a new Password "]
		defaults = ["", ""]
		results = UI.inputbox prompts, defaults, "Change Password"
		attrrdict = Sketchup.active_model.attribute_dictionary "cl_pw"
		old_pw = attrdict['pw']
		if results[0] == old_pw
			Sketchup.active_model.set_attribute "clf_pw", "pw", results[1]
		else
			UI.messagebox "Incorrect Password given"
			return
		end
	else
		prompts = ["Please enter a password"]
		defaults = [""]
		results = UI.inputbox prompts, defaults, "Set Password"
		Sketchup.active_model.set_attribute "clf_pw", "pw", results[0]
		Sketchup.active_model.set_attribute "clf_pw", "pw_set", true
		$clf_pw_set = true
	end
end
end

class Clf_model_scrambler

def activate
	if Sketchup.active_model.attribute_dictionary "clf_pw"
		attrdict = Sketchup.active_model.attribute_dictionary "clf_pw"
		$clf_pw_set = attrdict['pw_set']
	end
	if $clf_pw_set
		main
	else
		UI.messagebox " You need to set a password before scrambling the model"
		return
	end
end #activate

def main
	model = Sketchup.active_model
	ents = model.entities
	face_set = Set.new
	ents.each do |e|
		if e.typename == "Face" && e.valid?
			face_set.insert e
		end
	end
	face_set.each do |e|
		do_face e
		face_set.delete e
	end
	face_set.clear
end #main

def do_face face
	f_group = Sketchup.active_model.entities.add_group( face )
	f_group = f_group.to_component
	orig_t = f_group.transformation.clone
	f_group.set_attribute "clf_pw_comp", "1", a = orig_t.to_a[0]
	f_group.set_attribute "clf_pw_comp", "2", a = orig_t.to_a[1]
	f_group.set_attribute "clf_pw_comp", "3", a = orig_t.to_a[2]
	f_group.set_attribute "clf_pw_comp", "4", a = orig_t.to_a[3]
	f_group.set_attribute "clf_pw_comp", "5", a = orig_t.to_a[4]
	f_group.set_attribute "clf_pw_comp", "6", a = orig_t.to_a[5]
	f_group.set_attribute "clf_pw_comp", "7", a = orig_t.to_a[6]
	f_group.set_attribute "clf_pw_comp", "8", a = orig_t.to_a[7]
	f_group.set_attribute "clf_pw_comp", "9", a = orig_t.to_a[8]
	f_group.set_attribute "clf_pw_comp", "10", a = orig_t.to_a[9]
	f_group.set_attribute "clf_pw_comp", "11", a = orig_t.to_a[10]
	f_group.set_attribute "clf_pw_comp", "12", a = orig_t.to_a[11]
	f_group.set_attribute "clf_pw_comp", "13", a = orig_t.to_a[12]
	f_group.set_attribute "clf_pw_comp", "14", a = orig_t.to_a[13]
	f_group.set_attribute "clf_pw_comp", "15", a = orig_t.to_a[14]
	f_group.set_attribute "clf_pw_comp", "16", a = orig_t.to_a[15]
	vector = Geom::Vector3d.new( (rand(101)), (rand(101)), (rand(101)) )
	t = Geom::Transformation.translation vector
	f_group.transformation = t	
end #do_face

end #class


class Clf_password_unscrambler

def activate
	if Sketchup.active_model.attribute_dictionary "clf_pw"
		attrdict = Sketchup.active_model.attribute_dictionary "clf_pw"
		$clf_pw_set = attrdict['pw_set']
	end
	$clf_pw_valid = false
	model = Sketchup.active_model
	attrdict = model.attribute_dictionary "clf_pw"
	@pw = attrdict['pw']
	main
end

def main
	model = Sketchup.active_model
	ents = model.entities
	authorize_pw
	unscramble if $clf_pw_valid
end

def authorize_pw
	prompts = ["Please enter the password to authorize."]
	defaults = [""]
	results = UI.inputbox prompts, defaults, "Enter Password"
	if results[0] == @pw
		$clf_pw_valid = true
		UI.messagebox "You guessed correctly"
	else
		$clf_pw_valid = false
		UI.messagebox "Sorry sucker...only 3 more tries"
	end
end

def unscramble
	model = Sketchup.active_model
	ents = model.entities
	t_array = []
	comps_to_unscramble = []
	ents.each do |e|
		if e.attribute_dictionary "clf_pw_comp"
			comps_to_unscramble << e
		end
	end
	comps_to_unscramble.each do |e|
		attrdict = e.attribute_dictionary "clf_pw_comp"
		t_array[0] = attrdict['1']
		t_array[1] = attrdict['2']
		t_array[2] = attrdict['3']
		t_array[3] = attrdict['4']
		t_array[4] = attrdict['5']
		t_array[5] = attrdict['6']
		t_array[6] = attrdict['7']
		t_array[7] = attrdict['8']
		t_array[8] = attrdict['9']
		t_array[9] = attrdict['10']
		t_array[10] = attrdict['11']
		t_array[11] = attrdict['12']
		t_array[12] = attrdict['13']
		t_array[13] = attrdict['14']
		t_array[14] = attrdict['15']
		t_array[15] = attrdict['16']
		t = Geom::Transformation.new t_array
		e.transformation = t
		e.explode
		t_array = []
	end
end

end


if( $submenu )
	organizer = $submenu 
	if !file_loaded?(__FILE__) then
		organizer.add_item("Set PW") { Sketchup.active_model.select_tool Clf_password_protector.new }
	end
else
	if !file_loaded?('clf_menu_loader') then
		$clf_tools_menu = UI.menu("Plugins").add_submenu("Chris Fullmer Tools")
	end
	if !file_loaded?(__FILE__) then
		clf_password = $clf_tools_menu.add_submenu("Password Scrambler")
		clf_password.add_item("**Set PW**") { Sketchup.active_model.select_tool Clf_password_protector.new }
		clf_password.add_item("**Unscramble Model**") { Sketchup.active_model.select_tool Clf_password_unscrambler.new }
		clf_password.add_item("**Scramble Model**") { Sketchup.active_model.select_tool Clf_model_scrambler.new }
		
	end
end